import createBatch from '../src/createBatch';
import createWatergate from '../src/createWatergate';

const batch = createBatch({
    act1: {
        gate: 'graphql',
        msg: 'kaka'
    },
    act2: {
        gate: 'graphql',
        msg: 'pipi'
    },
    act3: {
        gate: 'fake',
        msg: 'kots'
    }
})

const createGraphqlGate = path => action =>
    action.__type === 'batch' ? processGraphqlBatch(action) : processGraphlAction(action)

const processGraphqlBatch = batch =>
    batch.actions

const processGraphlAction = action =>
    action


const createFakeGate = () => action =>
    action.__type === 'batch' ? processFakeBatch(action) : processFakeAction(action)

const processFakeBatch = batch =>
    batch.actions

const processFakeAction = action =>
    action

const watergate = createWatergate({
    graphql: createGraphqlGate('testpath'),
    fake: createFakeGate()
});

console.log(JSON.stringify(watergate.dispatch(batch), null, 4));
